// Open Source, for private use only! 
// Fahrpult nach SNM 33 2018, SW Beta Version
// Autor F. Bollow
// Vor Upload Fahrsteller auf Null stellen
//  

#define Version 45

#include <XpressNet.h> 
XpressNetClass XpressNet;

#include <TimerOne.h> 

#include "LedControl.h"
LedControl lc=LedControl(41,39,40,1);  // Pins: DIN,CLK,CS, # of Display connected

#include <TM1637Display.h>   
#define CLK_L       2
#define DIO_L       3
 
#define CLK_R       26
#define DIO_R       27
 
TM1637Display displayL(CLK_L, DIO_L); // instantiate an object
TM1637Display displayR(CLK_R, DIO_R); // instantiate an object

#include <EEPROM.h>   

#define hdDIM   16
#define EEPPV    2 * hdDIM
#define EEPpos   3 * hdDIM
#define LocoStep 8
#define LocoMAX 16
    
uint8_t data[] = { 0x00, 0x00, 0x40, 0x40 }; 
//    01
//  20  02
//    40
//  10  04
//    08  80 dp: displayL.setSegments(data)
uint8_t dataL[]    = { 0x38, 0,0,0};
uint8_t dataFull[] = { 0x71, 0x1C,0x18,0x18}; 
uint8_t dataH[]    = { 0x76, 0,0,0}; // unused 
uint8_t dataD[]    = { 0x5E, 0,0,0}; // unused
uint8_t dataC[]    = { 0x39, 0,0,0}; // unused
uint8_t dataE[]    = { 0x79, 0,0,0}; // unused
uint8_t dataP[]    = { 0x73, 0,0,0}; // PV
uint8_t data_[]    = { 0x18, 0,0,0}; // LV
uint8_t dataLnEu[] = { 0x38, 0x54,0x79,0x1C};
uint8_t dataLdEL[] = { 0x38, 0x5E,0x79,0x38};
uint8_t dataclear[]= { 0, 0, 0, 0};
uint8_t dataEEP[]  = { 0x79, 0x79,0x73,0};
uint8_t dataEEPF[] = { 0x79, 0x79,0x73,0x71}; 

//uint8_t data0[]  = { 0, 0,0,0x5C};
uint8_t data0[]    = { 0x5C };
uint8_t data1[]    = { 0x04 };
//uint8_t data1[]  = { 0, 0,0,0x04};

#define LedPin     13

#define Relay       4     // noise clic clac
#define myLamp      6     // Life-ticker & debug
#define PowerLedPin 7     // Signalisiert den Gleisspannungszustand
#define ButtonPin   8     // Taster zum Abschalten der Gleisspannung                          
#define PWMpin      9     // Speed-Anzeige   
#define Betriebart1 A0    // reserviert
#define BetriebartR A1    // Rangierbetrieb                

unsigned int loopcnt = 0;
unsigned long int t1 = 0UL;
unsigned long int t2 = 0UL;
unsigned long int tdiff = 0UL;

volatile unsigned long int tickerT1 = 0UL;
unsigned long int startzeitA = 0UL;
unsigned long int startzeitB = 0UL;
unsigned long int startzeitC = 0UL;
unsigned long int startzeitD = 0UL;
unsigned long int startzeitE = 0UL;
unsigned long int startzeitHorn  = 0UL;
unsigned long int startzeitRelay = 0UL;
unsigned long int startzeitBrake = 0UL;
bool lockHorn  = true;
bool lockRelay = true;
bool lockBrake = true;

byte KBDtaste = 100;  // Bei 0 wuerde F20 für 1. Lok gesetzt
bool Shift    = false;
byte RiBit    = 0x80; //Vorwaerts

#define  Key_A 13
#define  Key_B 14
#define  Key_C 15
#define ArrowL 12
#define ArrowR 16

boolean TPB0, TPB1, TPB2, TPB3, TPB4, TPB5, TPB6, TPH5 = LOW;  // Make
boolean TPBreak   = LOW;                                         // Break
boolean V0RMitte  = LOW;
boolean V0RMstat  = LOW;
boolean TstatusB0 = LOW;

boolean Fahrsperre = true; // true = gesperrt
unsigned int Fst = 0;

boolean RangierMode = false; // false = Zugmode

uint8_t spy = 0;

byte LEDmatrix[4] = {0x00,0x00,0x00,0x00}; // 4 Gruppen a 3 (4) LEDs  bits 0-3

#define t01sec    10
#define t02sec    20
#define t05sec    50
#define  t1sec   100
#define  t2sec   200
#define  t5sec   500
#define t10sec  1000
#define t20sec  2000
#define t40sec  4000
#define  t1min  6000
#define  t2min 12000
#define  t5min 30000
#define t10min 60000

#define LEDBrake  0
#define LEDDecoup 1
#define LEDLight  2
#define LEDVwarn  3

struct LOCO {
  uint16_t Lokadresse;  
  uint8_t  Lokmaxspeed;
  uint8_t  Lokspeedsteps;
  uint8_t  LokosInList;   // Anzahl der Loks im EEProm
}; // struct LOCO

struct LOCO LokSET;    // strukt. Var. LokSET

// globale Werte fuer die pultaktive Lok
uint8_t LadrAH     = 0;
uint8_t LadrAL     = 0;
uint8_t LmxSpeed   = 0;
uint8_t LspSteps   = 0;
uint16_t LokptrEEP = 0;

// EEP Header im RAM
 typedef struct {            // Struktur Header
  uint16_t res1;
  uint16_t offsetinfo;
  uint16_t offsetHeader;
  uint32_t wrcycle;  
  uint16_t EEid;
  uint16_t LocoLast;
  uint16_t LocoQuant;
  }EEP_t_hd;    // 16 Bytes
 union {
  EEP_t_hd hd;
  uint8_t bheader[hdDIM];
 }hdt, hdb;
  

// EEP Str im RAM
uint8_t RAM_EEPstr [hdDIM] = {0};

// Pult Variablen: PV0 - PV15 (zunächst PV0 - PV9 aenderbar duch user)
uint8_t PultPV[hdDIM] = {0};

// Zeiger für EEP
uint16_t LVindex = 0;
uint16_t PVindex = 0;

char str[128] = {__FILE__};
int slen = strlen(str);

uint8_t KeyTask = 0;        // Keybd Umlenkung nach Menuewahl
#define KeyTask_Func    0
#define KeyTask_Loco    1    
#define KeyTask_LDel    2
#define KeyTask_LVar    3
#define KeyTask_PVar    4

uint8_t  Gl_cnt       = 1;  // Global wg. Ruecksetzung Stellen bei Keybd input
uint8_t  Gl_ByteNum   = 0;
uint16_t Gl_KbdLocNum = 0;  // Global wg. Speichern mit Taste B

boolean BStatic       = false;
boolean RStatic       = false;

boolean EEP_failed    = false;
uint8_t XNetAddress   = 30;

//--------------------------------------------------------------------------------
// XpressNet address: must be in range of 1-31; must be unique. Note that some IDs
// are currently used by default, like 2 for a LH90 or LH100 out of the box, or 30
// for PC interface devices like the XnTCP.
// #define XNetAddress 30    //Adresse im XpressNet
// testweise geändert in:
// #define XNetAddress 21
#define XNetSRPin 5       //Max485 Busdriver Send/Receive-PIN
//--------------------------------------------------------------------------------

void setup() {                

displayR.setBrightness(2);
displayR.showNumberDec(8888, false);
delay(1000);
displayR.setSegments(data);  

displayL.setBrightness(2);
displayL.showNumberDec(Version, false);
delay(1000);
displayL.setBrightness(2);
displayL.showNumberDec(8888, false);

delay(1000);
displayL.setSegments(dataL);      // displ:  L

int p = 0;
//for(int i = slen, p=0; str[i] != '\\'; i--) {p = i;}  // 0x5C
Serial.begin(9600);   
Serial.print(__DATE__); Serial.print(" "); Serial.print(__TIME__);
Serial.print(" "); Serial.println(str+slen-22);

     Timer1.initialize(10000);   // 5000 mikros = 5 ms, 10000 mikros = 10 ms
     Timer1.attachInterrupt(ISR_timer1); 
          
startzeitC = currentT1();     
startzeitB = currentT1(); 
startzeitA = currentT1(); 

  pinMode(LedPin, OUTPUT);        // Ard 13, PB7, Verwendet zur "connect" Anzeige
  digitalWrite(LedPin, HIGH); 
  
  pinMode(PowerLedPin, OUTPUT);  // Ard 7, PH4, LED Track
  digitalWrite(PowerLedPin, LOW); // H bei Eckstein, sonst LOW

  pinMode(myLamp, OUTPUT);       // Ard 6, PH3, Test & Debug
  digitalWrite(myLamp, LOW);    // H bei Eckstein

  pinMode(Relay, OUTPUT);
  digitalWrite(Relay, LOW);

  pinMode(ButtonPin,INPUT_PULLUP); 

  pinMode(BetriebartR, INPUT_PULLUP);
  
  DDRA  = 0x00;        // Port A 8x Input
  PORTA = 0xFF;        // All Pullup

  DDRB  = 0x80;        // Port B 7x Input     // 0x00 ist ok, aber PB7 nicht für LED Ard 13
  PORTB = 0x7F;        // 7x Pullup           // 0xFF ist ok

  DDRK  = 0xFF; // Port K (A8 - A15) Output, A8-A11: 4 LEDs, A12-A15 LED Matrix (Hdrive)
  PORTK = 0x0F; // 0x0F bei Eckstein, sonst 0x00
  
  PORTL = 0x00;        // All pins Low, PL0-PL3 Kbd Ldrive, PL4-PL7 LED Matrix (Ldrive)
  // ------------------------------------------------------------------------------------
  Fahrsperre = true;       
  LEDset (0,LEDBrake);  
  delay(500);  // -B soll beim Start leuchten
  LEDset (1,LEDBrake);  
  
  // ------------------------------------------------------------------------------------

  // ------------------------------------------------------------------------------------

  ReadEEPhdStrPv();
  
  if (EEPcheck()) { // check 1
     // EEProm check Failed
     Serial.println("EEProm check 1 failed");
     EEP_failed = true;

     displayL.setSegments(dataEEP);
     
     EEPromWriteAll();                      // EEP Schreibversuch

     ReadEEPhdStrPv();
     
     if (EEPcheck()) { // check 2
       Serial.println("EEProm check 2 failed");
       EEP_failed = true;
       displayL.setSegments(dataEEPF);      
       delay(1000);
       }
     else { // check 2
       EEP_failed = false;
       Serial.println("EEProm check 2 ok");
       Serial.print("cyc: "); Serial.println(hdb.hd.wrcycle);
       }
         
  }
  else { // check 1
     EEP_failed = false;
     Serial.println("EEProm check 1 ok");
     Serial.print("cyc: "); Serial.println(hdb.hd.wrcycle);
  }
  
  // ------------------------------------------------------------------------------------
  // Falls EEP_failed = true, dann war das Beschreiben ohne Erfolg, Handlungsbedarf!
  // ------------------------------------------------------------------------------------  
  
  if (!EEP_failed) XNetAddress = PultPV[9]; 
  XpressNet.start(XNetAddress, XNetSRPin);    //Initialisierung XNet-Bus
  Serial.print("X-Bus Adress dez: "); Serial.println(XNetAddress);
  
  // ------------------------------------------------------------------------------------
  
  Serial.print("PV ");
  for (int k=0; k<3; k++) {
      Serial.print(k); Serial.print(":"); Serial.print(PultPV[k]);
      Serial.print(" ");
  }
  Serial.println();
  delay(1000);

  lc.shutdown(0,false);  // Wake up display
  lc.setIntensity(0,3);  // Set intensity levels  
  lc.clearDisplay(0);    // Clear Display

  //Ausgabe (0); //Lok Stop -> nicht wie gewuenscht, mM macht nicht mit
  
  XpressNet.getLocoInfo (LadrAH,LadrAL ); 

  NextLoco(ArrowL); // erste Lok aus EEPROM
  Serial.print("Locos in List:" ); Serial.println(LokSET.LokosInList);

  RelayOn();

  Stop_Loco();
  
}// setup


//----------------- isr ------------------------------------

void ISR_timer1() {
     extern volatile unsigned long int tickerT1;
     static int icnt = 0;
     static byte Talt = 0x7F;
     byte TastenPB;    
     byte Sact = 0;
     byte Salt = 0;
     byte BitMask = 0x40;

     static byte LEDMstate=1;
     
     tickerT1++;
     icnt++;
     digitalWrite(myLamp, LOW);
     
     kbdscan();
     
         if (icnt == 100) { 
            // Test here       
            icnt = 0;
        }              
  
     TastenPB = PINB & 0x7F;             // 2 schalter, 5 Tasten

     if ((TastenPB & 0x60) == 0x60) V0RMstat = true;
     else                           V0RMstat = false;
          
     TstatusB0 = !(TastenPB & 0x01); // Verwendung wie Shift für Rang. ein/aus

     if (TastenPB & 0x10) BStatic = false;
        else              BStatic = true;

     if (TastenPB & 0x02) RStatic = false;
        else              RStatic = true;   
     
     if (TastenPB != Talt) { // Tasten, Schalter geändert?        
           if ((TastenPB & 0x10) == 0)      TPB4 = HIGH; 
           else if ((TastenPB & 0x08) == 0) TPB3 = HIGH; 
           else if ((TastenPB & 0x04) == 0) TPB2 = HIGH; 
           else if ((TastenPB & 0x02) == 0) TPB1 = HIGH; 
           else if ((TastenPB & 0x01) == 0) TPB0 = HIGH;                       
        } // if 1
        else { //  Taste geloest             
             }
             
        // Schalter geändert ?    >>>>>>>>>>>>>>>>> ggf statische Erkennung bei Start erforderlich
        Sact = TastenPB & 0x60;  
        Salt = Talt     & 0x60;
        if ((Sact ^ Salt) != 0) { // changed?
           if (Sact == 0x60) {    // Mittelstellung?
               TPBreak = HIGH;    // ja
           } 
           else if ((Sact & 0x40) == 0) TPB6 = HIGH;
           else if ((Sact & 0x20) == 0) TPB5 = HIGH;
        }
       
     Talt = TastenPB;   
} // isr
//----------------------------------------------------------


unsigned long int currentT1(void) {
     return tickerT1;
}

boolean zeitabgelaufen (unsigned long int startzeit, unsigned long int wartezeit) {
     return (currentT1() - startzeit >= wartezeit);
}

void LifeLamp (void) {
static unsigned long int cnt = 0;
digitalWrite(myLamp,HIGH); // HIGH in isr
} // LifeLamp()

// ----------------- kbdScan ------------------------------


void kbdscan(void) {             // Aufruf durch ISR
  
     #define ARDIM 4
     static byte kbdstate   = -1;
     static byte kar[ARDIM] = {0x0F};
     static byte kmi[ARDIM] = {0x0F};
     byte kbdstatex3        = 0;
     byte proaktiv          = 0;
     
     kbdstate++;
     if (kbdstate == ARDIM) kbdstate = 0;
     kbdstatex3 = (kbdstate << 1) + kbdstate; // avoid mul     
     
     proaktiv = (PINK & 0x0F) | (LEDmatrix[kbdstate] << 4); // wg. Delay H-L Strobe
     
     switch (kbdstate) { // wird doppelt (2x 4 bit) gesetzt wg. ehem. LED Matrix
                         // Port PL0-PL3 ist Keyboard                                              
     case 0: DDRL  = 0x11;       // PL0+PL4: 1 2 3 kbd
           // 1 going Low, others hi-Z state    
     break;
     case 1: DDRL  = 0x22;       // PL1+PL5: 4 5 6
          // 1 going Low, others hi-Z state    
     break;
     case 2: DDRL  = 0x44;       // PL2+PL6: 7 8 9
           // 1 going Low, others hi-Z state    
     break;
     case 3: DDRL  = 0x88;       // PL3+PL7: * 0 #
           // 1 going Low, others hi-Z state      
     break;     
     default:     break;
     } // switch
     
     PORTK = proaktiv;      // LED Hdrive  
        
     delay(2);
     kar[kbdstate] = PINA & 0x0F; // Werte 0111,1011,1101,1110 //0x0F
                                  //       0x07,0x0B,0x0D,0x0E
     if (kar[kbdstate] != kmi[kbdstate]) {  // Aenderungen?
        if (kar[kbdstate] != 0x0F) {        // ja, welche?
           switch (kar[kbdstate]) {         // Tastendruck
           case 0x7:  KBDtaste = 13 + kbdstate;     break; // ABCD, 13...16
           case 0xE:  KBDtaste = 1 + (kbdstatex3); break;
           case 0xD: { 
                     KBDtaste = 2 + (kbdstatex3); 
                     if (kbdstate==3) KBDtaste = 0;
                     }
                     break;
           case 0xB:  KBDtaste = 3 + (kbdstatex3);  break;
           default: break;
           } // switch

           if (kmi[3] & 0x01) Shift = false; // wenn true, dann war Shift nicht gedrückt
           else Shift = true;
           
           KBDtaste = KBDtaste | 0x80; // sonst keine null h
           }
        else { };                 // Taste losgelassen, keine Aktivitaet
     }
     kmi[kbdstate] = kar[kbdstate];      
             
} // kbdscan()

//--------------------------------------------------------------------------------------------


//--------------------------------------------------------------------------------------------

void loop() {
 byte spy = 0;
  XpressNet.receive();  //permanent update the library

  LifeLamp ();
  CheckButton();  //check if Button push
 
  if (KBDtaste) {
     KBDtaste = KBDtaste & 0x7F;  

     switch (KBDtaste) {
     case ArrowL:
     case ArrowR: pfeiltaste(KBDtaste);
          break;
          
     case Key_A:
     case Key_B:
     case Key_C: abctaste(KBDtaste);
          break;
          
     case 10:     // shift wird vorher abgefangen
          break;
          
     default:     // 0...9
          switch (KeyTask) {
          case KeyTask_Func: 
               FuncNumber(KBDtaste);
               break;   
                              
          case KeyTask_Loco:
               LocoNumber(KBDtaste);
               break;

          case KeyTask_LVar:
               ByteValue(KBDtaste);
               break;
               
          case KeyTask_PVar:
               ByteValue(KBDtaste);
               break;
               
          default:
               break; 
          }         
     }
          
     KBDtaste = 0;
  } // if Taste
 
  
  if (zeitabgelaufen(startzeitC, t02sec)) {           
      Fahrsteller();
      startzeitC = currentT1();            // stetige Wiederholung  
     } 
   if (zeitabgelaufen(startzeitRelay, t01sec) && ! lockRelay) { 
      digitalWrite(Relay, LOW);
      lockRelay = true;                    // Ausfuehrung nur 1x nach Ausloesung
     }   
   if (zeitabgelaufen(startzeitBrake, t2min) && ! lockBrake) { 
      Fst = 0;
      Fahrsperre = true;
      displayR.showNumberDec(0, false);
      LEDset  (1,LEDBrake); 
      lockBrake = true;                    // Ausfuehrung nur 1x nach Ausloesung      

      RelayOn(); 
     }     
     /*
 if (zeitabgelaufen(startzeitHorn, t05sec) && ! lockHorn) { // 12->13 Nr. 5 und 7
     XpressNet.setLocoFunc(LadrAH,LadrAL,0,4);    // 2: toggle, 1: on  0: off
     lockHorn = true;                    // Ausfuehrung nur 1x nach Ausloesung
     }
*/ 
} //loop

// -------------------------------------------------------------------------
void FuncNumber(byte key) { // Toggeln einer Funktion F1-F10

     //displayL.showNumberDec(key, false);
     
     if (key == 0) key = 10;
     if (Shift) key = key + 10;
     XpressNet.setLocoFunc(LadrAH,LadrAL,2,key);  // Toggle
     Serial.print("F: ");Serial.println(key);
     XpressNet.getLocoInfo (LadrAH,LadrAL );
}



void LocoNumber(byte key) {  // Erzeugen einer dez. 1-4 stelligen Lokadresse (Gl_KbdLocNum)
       
    if (key <= 9) {
        switch (Gl_cnt) {
        case 1: Gl_KbdLocNum = key; 
                displayR.showNumberDec(Gl_KbdLocNum, false); 
                Gl_cnt++;    
                break;
        case 2: 
        case 3: 
        case 4: Gl_KbdLocNum = Gl_KbdLocNum * 10 + key; 
                displayR.showNumberDec(Gl_KbdLocNum, false); 
                Gl_cnt++;    
                break;
        default: 
               Gl_cnt=1;
               Gl_KbdLocNum=0;
               displayR.setSegments(data);      // displ:  --
        break;  
        }//switch  
    }   
    else { // key > 9, Neuanfang
       Gl_cnt=1;
       Gl_KbdLocNum=0;
       displayL.setSegments(data);      // displ:  --
    }// if
    
} // LocoNumber()


boolean LokExist(uint16_t LokSearch) {
boolean found = false;
uint16_t PtrEEP = 0;
uint8_t  LocoL  = 0;
uint8_t  LocoH  = 0;
uint16_t Loco   = 0;

for(int k=0; k<LocoMAX;k++) {     // Suche nach Lok
   PtrEEP = EEPpos + (k * LocoStep); 
   LocoL = EEPROM.read(PtrEEP);   
   LocoH = EEPROM.read(PtrEEP+1);      
   Loco  = (LocoH << 8) + LocoL; 
   if (Loco == LokSearch) found = true; 
   }   
return found;  
}


void ByteValue(byte key) {  // Erzeugen eines dez. 1-2 stelligen Byte-Wertes (Gl_ByteNum)
     if (key <= 9) {
        switch (Gl_cnt) {
        case 1: Gl_ByteNum = key;                 
                displayL.showNumberDec(Gl_ByteNum,false,2,2); 
                Gl_cnt++;    
                break;
       
        case 2: Gl_ByteNum = Gl_ByteNum * 10 + key; 
                displayL.showNumberDec(Gl_ByteNum,false,2,2); 
                Gl_cnt++;    
                break;
        default: 
               Gl_cnt=1;
               Gl_ByteNum=0;
               displayL.setSegments(data,2,2);      // displ:  --
        break;  
        }//switch  
    }   
    else { // key > 9, Neuanfang
       Gl_cnt=1;
       Gl_ByteNum=0;
       displayL.setSegments(data,2,2);      // displ:  --
    }// if  
    
} // ByteValue()

//-----------------------------------------------------------------------


void pfeiltaste(byte KBDtaste) {       // Aufruf durch Loop und 1x setup()

switch (KeyTask) {
case KeyTask_Func:
     NextLoco(KBDtaste);
     break;

case KeyTask_LVar:                // steppen durch LV0...LV5
     // LokptrEEP wird zu der pultaktiven Lok gespeichert
     LVindex++;
     if (LVindex > 5) LVindex = 0;
     displayL.showNumberDec(LVindex,false,1,1);
     displayL.showNumberDec(EEPROM.read(LokptrEEP +2 +LVindex),false,2,2);
     break;

case KeyTask_PVar:                // steppen durch PV0...PV9
     PVindex++;     
     if (PVindex > 9) PVindex = 0;
     displayL.showNumberDec(PVindex,false,1,1);
     displayL.showNumberDec(EEPROM.read(EEPPV+PVindex),false,2,2);     
     break;

default:
     KeyTask = KeyTask_Func;
     break;               
     } // switch

} // pfeiltaste()


void  NextLoco(byte KBDtaste) {

if (Fahrsperre) {      // nur bei stehender aktueller Lok Neuauswahl
    LokSET.Lokadresse = 0;  
    displayL.setSegments(dataL);

    noInterrupts();
    LokSET = ReadEEPLoco(KBDtaste);     // Lokdaten aus EEPROM
                                            // Taste ist < oder >
    displayL.showNumberDec(LokSET.Lokadresse, false); 
    interrupts();
    if (LokSET.Lokadresse <= 999) displayL.setSegments(dataL,1,0);   
    //---------------------------------------------------------------      
    // Lokadresse L, H aus integer berechnen
    Ladr_int_2AHAL(LokSET.Lokadresse);
    
    //---------------------------------------------------------------   
    // globale Lokwerte setzen
    LmxSpeed = LokSET.Lokmaxspeed;
    if ((LmxSpeed == 0) || (LmxSpeed > 14)) LmxSpeed = 14;
    
    LspSteps = LokSET.Lokspeedsteps & 0x03; //0,1,2,3    
    
    XpressNet.getLocoInfo (LadrAH,LadrAL );  
} // if Fahrsperre
      
} // NextLoco()
     

//-----------------------------------------------------------------------


void abctaste(byte KBDtaste) {  
static uint8_t displfunc = 0;
byte LocoLow = 0;
byte LocoHigh= 0;
uint16_t LocoHL = 0;
uint16_t k      = 0;
/*
 * Auftragsvergabe "Input" zB. mit Input-Verteiler
 * A0: F-Tasten, F1...F20
 * A1: Input Loknummer
 * A2: Input L/P Nummer
 * A3: Input Wert
 * 
 * using showNumberDec():
 *  (num,p2,len,pos), p2=false: fuehrende Nullen nicht anzeigen
 *                       true:  fuerende Nullen anzeigen
 *          len: Anzahl der Stellen            
 *          pos: 0 ganz links, 3 ganz rechts
 */

switch (KBDtaste) {  
  
case Key_A:                 // Menue Auswahl
    displfunc++;
    switch (displfunc) {
    case 1:                             // Lok neu
          KeyTask = KeyTask_Loco;
          Gl_cnt  = 1;                  // Stellenzaehler auf Anfang
          displayL.setSegments(dataLnEu);

          if (LokSET.LokosInList >= LocoMAX) {
             displayR.setSegments(dataFull);
             }
          else {
             displayR.setSegments(dataL);
             displayR.setSegments(data,2,3);      // displ:  --
          }
          // Input Loknummer          
          // nach Eingabe od. Taste B pruefen: Loknummer bereits in der Liste          
          break;
    case 2:                             // Lok loeschen
          KeyTask = KeyTask_LDel;
          displayL.setSegments(dataLdEL);
          displayR.showNumberDec(LokSET.Lokadresse,false);
          if (LokSET.Lokadresse <= 999) displayR.setSegments(dataL,1,0); 
          
          if (LokSET.LokosInList > 1) { // pruefen: Lokanzahl    
             // todo: Loeschfreigabe mit Taste B
             //         oder Abbruch mit Taste C
          }
          else {  // nur noch eine Lok, nicht loeschbar
               Serial.println("Last loco is non-eraseable"); 
               // Abbruch Lok loeschen
          }
           
          break;  
    case 3:                             // Lok Variable
          KeyTask = KeyTask_LVar;       // Taste -> (D) steppt
          LVindex = 0;
          Gl_cnt  = 1;
          displayL.setSegments(data_); 
          displayR.showNumberDec(LokSET.Lokadresse,false);
          if (LokSET.Lokadresse <= 999) displayR.setSegments(dataL,1,0);  
          
          displayL.showNumberDec(LVindex,false,1,1);
          displayL.showNumberDec(EEPROM.read(LokptrEEP +2 +LVindex),false,2,2);
          
          // LVs von 0...5 steppen mit Taste D         
          break; 
    case 4:                             // Pult Variable
          KeyTask = KeyTask_PVar;       // Taste -> (D) steppt
          PVindex = 0;
          Gl_cnt  = 1;
          displayL.setSegments(dataP); 
          displayR.setSegments(dataclear);
          
          displayL.showNumberDec(PVindex,false,1,1);
          displayL.showNumberDec(EEPROM.read(EEPPV + PVindex),false,2,2);
          
          // PV von 0...9 steppen mit Taste D
          displfunc = 0;
          break; 
          
    default:
          KeyTask = KeyTask_Func;
          break;                 
    } //switch displfunc
    
  break; // Key_A

case Key_B: {  // B-estaetigen, Speichern
     switch (KeyTask) {
     case KeyTask_Loco:
          if (LokSET.LokosInList > LocoMAX-1) goto Bend;    // ablehnen wenn voll      
          if (LokExist(Gl_KbdLocNum))         goto Bend;    // ablehnen wenn vorhanden
          
          k = 0;          
          do {                       // Suche nach Loch
             LokptrEEP = EEPpos + (k * LocoStep);
             LocoLow  = EEPROM.read(LokptrEEP);
             LocoHigh = EEPROM.read(LokptrEEP+1);
             LocoHL   = (LocoHigh<<8)+ LocoLow;
             k++;
          }
          while (LocoHL);            // Wiederholung wenn kein Loch
          
          Serial.print("Inhalt Lokptr:");Serial.println(LocoHL);  
                       
          LmxSpeed = 14;        // defaults, indiv. via Menue setzen
          LspSteps = 3;          
          // Loknummer (int) vom Keyboard in 2x Ladr wandeln 
          Ladr_int_2AHAL(Gl_KbdLocNum);  
                             
          LokSET.Lokadresse    = Gl_KbdLocNum;  
          LokSET.Lokspeedsteps = LspSteps;
          LokSET.Lokmaxspeed   = LmxSpeed;
          LokSET.LokosInList++;

          // 4x write...
          
          EEPROM.write(LokptrEEP,   Gl_KbdLocNum & 0x00FF);
          EEPROM.write(LokptrEEP+1, Gl_KbdLocNum >> 8);
          EEPROM.write(LokptrEEP+2, LmxSpeed);
          EEPROM.write(LokptrEEP+7, LspSteps);
          
          Serial.print("New Loco: ");Serial.println(LokSET.Lokadresse);
     Bend:
          break;

     case KeyTask_LDel:         // delete Loco
          // nur hier EEProm.write()
          Serial.print("Locos: ");Serial.println(LokSET.LokosInList);
          if (LokSET.LokosInList > 1) {
             EEPROM.write(LokptrEEP,  0);
             EEPROM.write(LokptrEEP+1,0);
             Serial.print("Loco deleted: ");Serial.println(LokSET.Lokadresse);
             NextLoco(ArrowR);   // nach loeschen Lok 
             }          
          break;     
          
     case KeyTask_LVar:    // write LV          
          Serial.print("LVi ");Serial.print(LVindex);
          Serial.print(" Value ");Serial.println(Gl_ByteNum);
          EEPROM.write(LokptrEEP +2 + LVindex,Gl_ByteNum);
          LVindex = 0;
          break;
          
     case KeyTask_PVar:    // write PV
          Serial.print("PVi ");Serial.print(PVindex);
          Serial.print(" Value ");Serial.println(Gl_ByteNum);
          EEPROM.write(EEPPV + PVindex,Gl_ByteNum);
          PVindex = 0;
          break;         

     case KeyTask_Func:
          if (RStatic && Shift) {
             EEPromWriteAll();
             Serial.println(" EEProm write complete");
          }
          break;
          
     default:
          break;     
     } // switch KeyTask     

     KeyTask = KeyTask_Func;  
     noInterrupts();
     displayL.showNumberDec(LokSET.Lokadresse, false); 
     if (LokSET.Lokadresse <= 999) displayL.setSegments(dataL,1,0);      
     displayR.showNumberDec(Fst,false);  
     interrupts();
     displfunc = 0;        
} // case Key_B

break;  // Key_B
     
case Key_C:    // C-lear, Abruch ohne Speichern   
   
     KeyTask = KeyTask_Func; 
     noInterrupts();
     displayL.showNumberDec(LokSET.Lokadresse, false); 
     if (LokSET.Lokadresse <= 999) displayL.setSegments(dataL,1,0);      
     displayR.showNumberDec(Fst,false);      
     interrupts();                            
     displfunc = 0;
     LVindex   = 0;
     PVindex   = 0;
    
     break;
     
default:
     break;         
       
  }  // switch KBDtaste   

} // abctaste()

//--------------------------------------------------------------------------------------------
void CheckButton()   // Aufruf durch loop
{
static byte LiState = 0;
static boolean TPH5alt, TPH5act = HIGH;
boolean BartStateR = LOW;                               

BartStateR = !digitalRead(BetriebartR);                 // Modus Abfrage R, wenn Low Rangiermode erwünscht

TPH5act = digitalRead(ButtonPin);                       // Sonderfall, weil anderer Byte-Port

   if ((TPH5act == LOW) && (TPH5alt == HIGH)) {
        TPH5 = HIGH;
   }
//--------------------------------------------------------------------------------------------
// Abfrage, auf Betriebsart
   
       if (Fst <= 1) {        // Nur dann Bart wechsel
          if (BartStateR) {
             RangierMode = true;
             LEDset (1,LEDDecoup);
          }
          else {
             RangierMode = false;
             LEDset (0,LEDDecoup);
          }                   
       } 

//--------------------------------------------------------------------------------------------
// Abfrage, ob bestimmte Schalter losgelassen wurden (Break)

 if (TPBreak) {           // Fahrtrichtungshebel in Mittelstellung
     TPBreak = LOW;
     V0RMitte = HIGH;     

     RelayOn();

     if (RangierMode) {
          XpressNet.setLocoDrive(LadrAH,LadrAL,0x03,0 | RiBit);
          analogWrite(PWMpin, 0);
          Fahrsperre = true;
          XpressNet.getLocoInfo (LadrAH,LadrAL );     //Gibt den mM Status zurück, ok F0-F12              
     }
     else {        // Zugfahrt
          lc.setRow(0,5,0);                           // Pfeil oben und unten loeschen
          lc.setRow(0,7,0); 
          Fahrsperre = true;
          displayR.showNumberDec(0, false);   
          LEDset  (1,LEDBrake);         
          XpressNet.getLocoInfo (LadrAH,LadrAL );     //Gibt den mM Status zurück, ok F0-F12  
          
          if (Fst != 0) { // Zug faehrt
             // Nothalt ohne Bremsverzögerung (Speed = 1)             
             XpressNet.setLocoDrive(LadrAH,LadrAL,0x03,1 | RiBit);
             analogWrite(PWMpin, 0);
             Fst = 0;             
             }           
     } // else Zugfahrt
  } // if TPBreak

//--------------------------------------------------------------------------------------------
// Abfrage, ob bestimmte Schalter und Taster betaetigt wurden (Make)

   if (TPB4) {                   // Ard10, Taste Brake 
     TPB4 = LOW;  
     
     RelayOn();  
     //---------------------------------------------                          
     if (Fahrsperre) { // if 1
         if ((Fst < 2) && (!V0RMstat))  {          // Freigabe möglich?
             LEDset (0,LEDBrake);  // Freigabe             
             Fst = 0;
             Fahrsperre = false;
             }        
     }
     else  { // if 1                     // Sperrung gewünscht
           Stop_Loco();
     }
     
     //---------------------------------------------       
  } // if TPB4
  
  //-----------------------------------------------
  if (TPB5) {                              // Ard11, Schalter Direction Reverse
     TPB5 = LOW;                           // 
     V0RMitte = LOW;

     RelayOn();

     if (RangierMode) {
        RiBit = 0x00; // MSB = 0: Rueckwaerts
        Fahrsperre = false;
        Ausgabe(Fst);
        XpressNet.getLocoInfo (LadrAH,LadrAL );     //Gibt den mM Status zurück, ok F0-F12
     }
     else  if (Fst == 0) {                       // Ri Umschaltung nur im Stillstand
           RiBit = 0x00; // MSB = 0: Rueckwaerts
           
           XpressNet.setLocoDrive(LadrAH,LadrAL,0x03,0 | RiBit);
           analogWrite(PWMpin, 0);
           XpressNet.getLocoFunc (LadrAH,LadrAL );       // Test: F13 -F20 (F28)  ?? kein Aufruf notifyLokFunc()
           XpressNet.getLocoInfo (LadrAH,LadrAL );     //Gibt den mM Status zurück, ok F0-F12
       
           }
           else { // Nothalt ohne Bremsverzögerung (Speed = 1)
           XpressNet.setLocoDrive(LadrAH,LadrAL,0x03,1 | RiBit);
           analogWrite(PWMpin, 0);
           Fst = 0;
           Fahrsperre = true;
           displayR.showNumberDec(0, false);   
           LEDset (1,LEDBrake);           
           XpressNet.getLocoInfo (LadrAH,LadrAL );     //Gibt den mM Status zurück, ok F0-F12
           }    
     
  } // if TPB5
  
  //----------------------------------------------- 
  if (TPB6) {                              // Ard12, Schalter Direction Forward
     TPB6 = LOW;                           // 
     V0RMitte = LOW;

     RelayOn();

     if (RangierMode) {
        RiBit = 0x80; // MSB = 1: Vorwaerts
        Fahrsperre = false;
        Ausgabe(Fst);
        XpressNet.getLocoInfo (LadrAH,LadrAL );     //Gibt den mM Status zurück, ok F0-F12
     }
     else  if (Fst == 0) {                       // Ri Umschaltung nur im Stillstand
           RiBit = 0x80; // MSB = 1: Vorwaerts
             
           XpressNet.setLocoDrive(LadrAH,LadrAL,0x03,0 | RiBit);
           analogWrite(PWMpin, 0);
           XpressNet.getLocoFunc (LadrAH,LadrAL );       // Test: F13 -F20 (F28)  ?? kein Aufruf notifyLokFunc()
           XpressNet.getLocoInfo (LadrAH,LadrAL );     //Gibt den mM Status zurück, ok F0-F12
     
           }
           else { // Nothalt ohne Bremsverzögerung (Speed = 1)
           XpressNet.setLocoDrive(LadrAH,LadrAL,0x03,1 | RiBit);
           analogWrite(PWMpin, 0);
           Fst = 0;
           Fahrsperre = true;
           displayR.showNumberDec(0, false);   
           LEDset (1,LEDBrake);  
           XpressNet.getLocoInfo (LadrAH,LadrAL );     //Gibt den mM Status zurück, ok F0-F12
           }

  } // if TPH6
  
 //-----------------------------------------------
      // Tastensonderfall, Port PH5   
  if (TPH5) {                        // Ard8, Taste Trackpower off 
     TPH5 = LOW;   
     //digitalWrite(PowerLedPin, digitalRead(PowerLedPin) ^1); // Test
     
     if (XpressNet.getPower() != csTrackVoltageOff)  //just send when State is not Power OFF
         XpressNet.setPower(csTrackVoltageOff);   
      
  } //if TPH5

//-----------------------------------------------
  if (TPB3)                             // Ard50, Taste H, Horn 
     {TPB3 = LOW; 
     //---------------------------------------------  
     XpressNet.setLocoFunc(LadrAH,LadrAL,2,4);    // 2: toggle, 1: on 
     
     //---------------------------------------------  
  } // if TPB3
     
//-----------------------------------------------     
  if (TPB2)                             // Ard51, Taste Licht 
     {TPB2 = LOW; 
     //---------------------------------------------       
     LiState++;                      
     switch (LiState){        
     case 1:     
          XpressNet.setLocoFunc(LadrAH,LadrAL,1,0);   // F0 on, 2: toggle, 1: on
          LEDset (1,LEDLight);
     break;
     case 2:
          XpressNet.setLocoFunc(LadrAH,LadrAL,1,1);   // F1 on
     break;
     case 3:
          XpressNet.setLocoFunc(LadrAH,LadrAL,0,0);  
          XpressNet.setLocoFunc(LadrAH,LadrAL,0,1);  
          LEDset (0,LEDLight);
          LiState = 0;
     break;
     default:
     break;
     XpressNet.getLocoInfo (LadrAH,LadrAL );
     //---------------------------------------------  
     } // switch
     
  } // if TPB2
  
//----------------------------------------------- 
  if (TPB1)                            // Ard52, Taste Entkuppler 
     {TPB1 = LOW; 
     //---------------------------------------------  
     if (RangierMode) {
         XpressNet.setLocoFunc(LadrAH,LadrAL,2,2);    // 2: toggle, 1: on 
     }
     //---------------------------------------------  
     } // if TPB1
     
//-----------------------------------------------   
  if (TPB0)                            // Ard53 Taste S 
     {TPB0 = LOW; 
     //---------------------------------------------  

     if (PultPV[0] == 0) { // if 
         XpressNet.setLocoDrive(LadrAH,LadrAL,0x03,0 | RiBit); // Halt mit Fst = 0
         analogWrite(PWMpin, 0);
         lockBrake = false;
         startzeitBrake = currentT1();
         //Fst = 0;
         //Fahrsperre = true;
         //displayR.showNumberDec(Fst, false); 
     //XpressNet.setLocoHalt(LadrAH,LadrAL);   // Das ist der Nothalt mit Fst = 1
     /*
     if (!RangierMode) {      
         LEDset (1,LEDBrake);
         RelayOn();
        }*/
     }
     else { // if PultPV
        if (PultPV[0] > 20) PultPV[0] = 20;
           FuncNumber(PultPV[0]);
     }
     //---------------------------------------------     
     } // if TPB0 

TPH5alt = TPH5act;

} // Check button ()

//----------------------------------------------- 

void RelayOn() {
     digitalWrite(Relay, HIGH); 
     lockRelay = false; 
     startzeitRelay = currentT1();    
} // RelayOn()

//----------------------------------------------- 


void LEDset (byte LEDstate, byte lednum) { // num = P0-P3
     // LED0 0x01, LED1 0x02, LED2 0x04, LED3 0x08
     byte BitMask = 1;

     BitMask = BitMask << (lednum & 0x03);
     switch (LEDstate) {
     case 0: // LED OFF                     // 
           PORTK = PINK & ~BitMask; 
           break;
     case 1: // LED ON                      // 
           PORTK = PINK | BitMask; 
           break;
     case 2: //LED invers
           PORTK = PINK ^ BitMask;
           break;
     default:
     break;
     } // switch
} // LEDset ()

// ----------------------------------------------
// Aufruf extern:

void notifyLokFunc(uint8_t Adr_High, uint8_t Adr_Low,  uint8_t F2, uint8_t F3 )
{
 Serial.print("notifyLokFunc():");                // Lenz Doku S. 
 Serial.print(" S0: ");Serial.print(F2,BIN);
 Serial.print(" S1: ");Serial.println(F3,BIN);  
}

uint16_t bitreverse(uint16_t x) {
  uint16_t total = 0;  

  for (int n=0; n < 8; n++) {       
       total = total << 1;
       total += x & 1; // modulo operation
       x = x >> 1;
    }
  return total; 
} // bitreverse


void notifyLokAll(uint8_t Adr_High, uint8_t Adr_Low, boolean Busy, 
                  uint8_t Steps, uint8_t Speed, uint8_t Direction, 
                  uint8_t F0, uint8_t F1, uint8_t F2, uint8_t F3, boolean Req )
{
static uint8_t F0rev = 0;
static uint8_t F1rev = 0;
static uint8_t F2rev = 0;

uint16_t LadrDez  = 0;

uint8_t LEDarray[] = {    1,  // i=0
                          1,
                          1,
                          1,
                          0,  // i=4
                        0x02, // i=5
                        0x01,
                        0x02,
                        0x40, // i=8 
                        0x80,
                        0x40};  
// Ladr dezimal:
if (Adr_High == 0) LadrDez = Adr_Low;                          
else               LadrDez = ((Adr_High << 8) + Adr_Low) - 0xC000;

if (LadrDez == LokSET.Lokadresse) {  // Schutz vor nachlaufenden notify´s
  
    //noInterrupts();
    displayR.showNumberDec(Speed, false);
    displayL.showNumberDec(LadrDez,false);
    if (LadrDez <= 999) displayL.setSegments(dataL,1,0);
    Serial.print("Ext. Ladr: "); Serial.println(LadrDez);
    //interrupts();
    
    F0rev = bitreverse(F0);
    F1rev = bitreverse(F1);
    F2rev = bitreverse(F2);
    
    LEDarray[0] = F0rev & 0xF0;
    if (F1rev & 0x80) LEDarray[0] = LEDarray[0] | 0x08;
                 else LEDarray[0] = LEDarray[0] & ~0x08;
    
    LEDarray[1] = (F1rev << 1) & 0xF8; // F6 ... F10
    LEDarray[2] = ((F1rev << 6) | ((F2rev >> 2)) & 0xF8);        // F11, F12 + F13 .. F15
    LEDarray[3] = F2rev << 3;                                    // F16 ... F20
    
    for (int i = 0; i < 4; i++) lc.setRow(0,i,LEDarray[i]);
     
    if (Direction) for (int i = 0; i < 3; i++) lc.setRow(0,i+5,LEDarray[i+5]);
    else           for (int i = 0; i < 3; i++) lc.setRow(0,i+5,LEDarray[i+8]);
    
    if (V0RMitte) {      // statt Pfeil nur Punkte
       lc.setRow(0,5,0);
       lc.setRow(0,7,0);
    }
    //Serial.print(Busy);
    //Serial.print(" Direction: ");Serial.println(Direction,BIN);
    
    LEDset (Busy,LEDVwarn); // weisse LED auf Zustand Busy
    
    // Update LED F0
    if (F0 & 0x10) LEDset(1,LEDLight);
    else           LEDset(0,LEDLight);  
    }



} // end notifyLokAll()



// Anfordern: getLocoStateFull (byte Adr_High, byte Adr_Low, bool bc) 
// dann wird  notifyLokAll()   aufgerufen              


//--------------------------------------------------------------------------------------------
void notifyXNetStatus (uint8_t State)
{
  digitalWrite(LedPin, State); // Blinkt, wenn keine Xpressnet-Verbindung
}

//--------------------------------------------------------------------------------------------
void notifyXNetPower (uint8_t State)
{
  switch (State) {
    case csNormal: digitalWrite(PowerLedPin, LOW); break;
    case csTrackVoltageOff: digitalWrite(PowerLedPin, HIGH); break;
    case csEmergencyStop: digitalWrite(PowerLedPin, LOW); break;
    case csShortCircuit: digitalWrite(PowerLedPin, HIGH); break;
    case csServiceMode: digitalWrite(PowerLedPin, HIGH); break;
  }
}
 
#define ANLGin A2

long int Poti = 0;
long int Mwert= 0;
int PotiAct   = 0;
int PotiFirst = 0;
int Medianwert= 0;
int maxwert   = 0;
int maxpos    = 0;
int oben      = 0;
int Fstalt    = 0;
int Zuendwert = 0;
int FstAktiv  = 0;
int delta     = 0;

#define parDIM 11
int parray[parDIM]  = {1, 2,1203, 1, 18, 27, 60, 12, 3, 432, 11};

int State = 1;
unsigned int Fs1sum = 0;
//--------------------------------------------------------------------

void Fahrsteller(void) {

   PotiFirst  = analogRead(ANLGin);
   
   Mwert      = 0;
   for(int i=0; i<parDIM;i++) {   // Werte sammeln Mittelwert bilden
       PotiAct   = analogRead(ANLGin); 
       parray[i] = PotiAct;
       Mwert     = Mwert + PotiAct; 
   }//for
   Mwert = Mwert/parDIM; 
  
  // Sortieren   
     
   for(int ar = parDIM-1; ar > 0; ar--) {
      for(int i=0; i <= ar; i++) {
         if (parray[i] > maxwert) {
            maxpos = i;
            maxwert= parray[i];
         } // if       
      }// for innen (suche maxwert)  
      oben = parray[ar];
      parray[ar] = maxwert;
      parray[maxpos] = oben;
      maxpos =0;
      maxwert=0;       
   }// for aussen

   Medianwert =parray[parDIM/2];
   delta = parray[parDIM-1] - parray[0];

   // hier ständige Kalkulation
   Poti = Medianwert - 23;  //ab 24 kann Fst 1 statt 3 folgen...
   if (Poti < 0) Poti = 0;
   Fst  = Poti >> 3;  // ab 23+8 = 31 -> Fst 1
   if (Fst == 1) {
      Fst = 2;     // Lenz: 1 ist Nothalt
      Fs1sum++;
      }
   
// -------------------------------------------------------------------
 
// hier Entscheidung ob neue Fst ausgegeben oder beibehalten wird
   
   if (Fstalt != Fst) { // Fenster um Zuendwert bilden, nur bei überschreiten Ausgabe
      // Ausgabe moeglich
      if (abs (Medianwert-Zuendwert) > 5) {         
         Ausgabe (Fst);
         }      
   }  
// -------------------------------------------------------------------      
} // Fahrsteller()


void Ausgabe (int Fst) {   
     uint16_t PWMVal = 0;             
    
     if (!Fahrsperre) {
         XpressNet.setLocoDrive(LadrAH,LadrAL,0x03,Fst | RiBit);
         displayR.showNumberDec(Fst, false);   
         PWMVal = (LmxSpeed * Poti)/56;
         analogWrite(PWMpin, PWMVal);    

         lockBrake = true;  // fuer den Fall Wiederanfahrt nach Taste S mit PV0=0     
     }
     Zuendwert = Medianwert;  
     Fstalt   = Fst;   
     FstAktiv = Fst;
     if (Fst == 0) {Zuendwert = 0;};
     
} // Ausgabe


struct LOCO ReadEEPLoco(byte TastenNumb) {  
  
    struct        LOCO Lvar;
    
    static int    LokListptr = 0;              
    uint16_t      Loco   = 0;
    byte          LocoL  = 0;
    byte          LocoH  = 0;
    int           PtrEEP = 0;   
    byte          LocoCnt= 0; 
    
    do {        // Stepper, durchlaeuft Liste mit Loechern
       if (TastenNumb == ArrowR) { 
          LokListptr++;
          if (LokListptr >= LocoMAX) LokListptr=0;
       }
       else {
          LokListptr--;
         if (LokListptr < 0) LokListptr=LocoMAX-1;
       } // if 
      PtrEEP = EEPpos + (LokListptr * LocoStep);               
      LocoL = EEPROM.read(PtrEEP);   
      LocoH = EEPROM.read(PtrEEP+1);      
      Loco  = (LocoH << 8) + LocoL;      
    } // while
    while (Loco==0); // wenn wahr, dann Wiederholung

    LokptrEEP = PtrEEP;
    Lvar.Lokadresse    = Loco;
    Lvar.Lokmaxspeed   = EEPROM.read(PtrEEP+2);  
    Lvar.Lokspeedsteps = EEPROM.read(PtrEEP+7);  

    LocoCnt=0;
    for(int k=0; k<LocoMAX;k++) {     // Anzahl feststellen
       PtrEEP = EEPpos + (k * LocoStep); 
       LocoL = EEPROM.read(PtrEEP);   
       LocoH = EEPROM.read(PtrEEP+1);      
       Loco  = (LocoH << 8) + LocoL;    
       if (Loco) LocoCnt++;   
    }
    Lvar.LokosInList   = LocoCnt;
    //Serial.print(LokListptr);Serial.print(" ");
    
    Serial.print("Loco: "); Serial.println(Lvar.Lokadresse);
    return (Lvar);
} // ReadEEPLoco ()


boolean NumberInList(uint16_t Locoadr) {
  
  uint16_t      Loco   = 0;
  byte          LocoL  = 0;
  byte          LocoH  = 0;
  int           PtrEEP = 0;   
   
  for (int k = 0; k < LocoMAX; k++) {
      PtrEEP = EEPpos + (k * LocoStep); 
      LocoL = EEPROM.read(PtrEEP);   
      LocoH = EEPROM.read(PtrEEP+1);      
      Loco  = (LocoH << 8) + LocoL; 
      if (Loco == Locoadr) break; 
  } // for
return (Loco == Locoadr);
} // Locoadr()


void Ladr_int_2AHAL(uint16_t Ladr) {
     if (Ladr > 99) {
         LadrAH = (Ladr >> 8) | 0xC0;
         LadrAL =  Ladr & 0x00FF;
         }
     else {
         LadrAH = 0;
         LadrAL = Ladr & 0x00FF;
         }  
} // Ladr_int_2AHAL()

     
void EEPromWriteAll(void) {
  
uint16_t lenArray  = 0;
uint16_t lenEEP    = EEPpos + (LocoStep * LocoMAX);
uint16_t nonZptr   = 0; // Zeiger auf Tab. der nz
uint8_t  nonZVal   = 0; // Wert der nz
uint16_t nonZTab   = 0; // pos. der nz

static uint8_t EEPnonZeros[] =
                 { 0x06,0xAE,0x07,0x03,0x09,  
                   0x4A,0x75,0x6E,0x20,0x31,0x35,0x20,0x32,0x30,0x31,0x38,
                   0x02,0x15,0x01,0x01,
                   0x58,0x16,0x08,0x03,
                   0xA0,0x0E,0x01,0x05,0x02,0x03,0x03,0x0E,0xFF,0x07,0xFF,0xFF,0x02,
                   0x1E,0x03,0x0A,0x03,
                   0x32,0x0E,0x03,0x59,0x08,0x03,
                   0x63,0x03,
                   0x16,0x07,0x03,
                   0x14,0x08,0x03};    

static uint8_t NZptr [] = 
                  {0x06,0x0A,0x0B,0x0C,0x0E,
                   0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1A,
                   0x21,0x29,0x2E,0x2F,
                   0x38,0x39,0x3A,0x3F,
                   0x40,0x42,0x43,0x44,0x45,0x47,0x48,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
                   0x50,0x51,0x52,0x57,
                   0x60,0x62,0x67,0x68,0x6A,0x6F,
                   0x70,0x77,
                   0x88,0x8A,0x8F,
                   0xA8,0xAA,0xAF};

lenArray  = sizeof(NZptr);

for (int k=0;k < lenEEP;k++) {
    nonZTab = NZptr[nonZptr];
    nonZVal = EEPnonZeros[nonZptr];
    
    if (k == nonZTab) {   // write non zero
       //Serial.print(nonZVal,HEX);Serial.print(" ");
       EEPROM.write(k,nonZVal);
       nonZptr++;
    } else {              // write zero
      //Serial.print(0);Serial.print(" ");  
      EEPROM.write(k,0);    
    }
    //if (!((k+1) % 16)) Serial.println();
} // for 

//Serial.print("size: ");Serial.println(lenArray);
Serial.print("sizeEEP: ");Serial.println(lenEEP);
}  // EEPromWriteAll()                 

                   
uint8_t EEPcheck(void) {

uint8_t ERRcnt = 0;
if (hdb.hd.EEid != 0x7AE) ERRcnt++;
   for(int k=0;k < 5;k++) {
      if ((RAM_EEPstr[k] < 0x20) || (RAM_EEPstr[k] > 0x7E)) ERRcnt++;
   }
return ERRcnt;
} // EEPcheck()


void ReadEEPhdStrPv(void) {
  
  for(int i=0;i < hdDIM; i++) hdb.bheader[i] = EEPROM.read(i);        
   
  for(int i=0;i < hdDIM; i++) {
    RAM_EEPstr[i] = EEPROM.read(i+(hdDIM)); // 16 ... 31
  }   
  for(int i=0;i < hdDIM; i++) PultPV[i] = EEPROM.read(i+(hdDIM * 2)); // 32 ... 47
  
} // ReadEEPhdStrPv()


void Stop_Loco(void) {
     XpressNet.setLocoDrive(LadrAH,LadrAL,0x03,0 | RiBit);  // Stop      
     analogWrite(PWMpin, 0);  
     displayR.showNumberDec(0, false);  // wg. Taste S mit PV0=0 
     LEDset (1,LEDBrake);
     Fahrsperre = true;
     Fst = 0;
} // Stop_Loco(

